/*  $Id: outputsource_netpacket.cpp,v 1.5 2003/07/20 22:34:40 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "API/Network/NetSession/outputsource_netpacket.h"
#include "API/Network/NetSession/netpacket.h"
#include "outputsource_netpacket_generic.h"
#include "netpacket_generic.h"

/////////////////////////////////////////////////////////////////////////////
// CL_OutputSource_NetPacket construction:

CL_OutputSource_NetPacket::CL_OutputSource_NetPacket(const CL_NetPacket &netpacket)
: impl(new CL_OutputSource_NetPacket_Generic(netpacket.impl, true))
{
}

CL_OutputSource_NetPacket::~CL_OutputSource_NetPacket()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// CL_OutputSource_NetPacket attributes:

int CL_OutputSource_NetPacket::tell() const
{
	return impl->position;
}

int CL_OutputSource_NetPacket::size() const
{
	return impl->netpacket->size;
}

/////////////////////////////////////////////////////////////////////////////
// CL_OutputSource_NetPacket operations:

int CL_OutputSource_NetPacket::write(const void *data, int size)
{
	impl->netpacket->resize(impl->position+size);
	memcpy(impl->netpacket->data+impl->position, data, size);
	impl->position += size;
	return size;
}

void CL_OutputSource_NetPacket::open()
{
}

void CL_OutputSource_NetPacket::close()
{
}

CL_OutputSource *CL_OutputSource_NetPacket::clone()
{
	return new CL_OutputSource_NetPacket(*this);
}

/////////////////////////////////////////////////////////////////////////////
// CL_OutputSource_NetPacket implementation:

CL_OutputSource_NetPacket::CL_OutputSource_NetPacket()
: impl(new CL_OutputSource_NetPacket_Generic(0, false))
{
}
